=== modified file 'rules/annotations/method_defs.rules'
--- old/rules/annotations/method_defs.rules	2022-05-16 16:24:45 +0000
+++ new/rules/annotations/method_defs.rules	2022-05-22 12:43:27 +0000
@@ -39,6 +39,8 @@
 **                  and the javaname must be changed).
 **     CA  20220516 For extent OO properties, we need both indexed and bulk setters, plus bulk getters, 
 **                  regardless if there are explicit indexed setters/getters at the property definition.
+**     GES 20220522 Reworked to properly separate and handle the method names for the extent property bulk
+**                  getter, bulk setter and "all" setter. 
 */
 -->
 
@@ -149,10 +151,13 @@
    <variable name="childref"     type="com.goldencode.ast.Aast" />
    
    <func-library access="private">
+   
+      <!-- called with copy as KW_GET or KW_SET -->
       <function name="process_getter_setter">
-         <parameter name="mref"    type="com.goldencode.ast.Aast" />
-         <parameter name="tref"    type="com.goldencode.ast.Aast" />
-         <parameter name="indexed" type="java.lang.Boolean" />
+         <parameter name="mref"     type="com.goldencode.ast.Aast" />
+         <parameter name="tref"     type="com.goldencode.ast.Aast" />
+         <parameter name="indexed"  type="java.lang.Boolean" />
+         <variable  name="javaname" type="java.lang.String" />
          
          <rule>true
             <rule>isAbstract
@@ -233,7 +238,7 @@
             </rule>
             
             <rule>extent != null and extent != 0
-               <!-- emit the bulk setter and getter, single-value setter -->
+               <!-- emit the bulk setter, "all" setter and bulk getter -->
                <rule>indexed
                   <action>tref = mref.graftCopyTo(mref.parent, null)</action>
                   <action on="false">tref = mref</action>
@@ -242,6 +247,13 @@
                <rule>type == prog.kw_get
                   <!-- bulk getter -->
                   
+                  <!-- lookup and copy the bulk getter javaname (was deferred from naming.rules) -->
+                  <rule>copy.parent.isAnnotation("bulk-get-javaname")
+                     <action>javaname = copy.parent.getAnnotation("bulk-get-javaname")</action>
+                     <action on="false">javaname = "method_defs.rules_FIXME1"</action>
+                  </rule>
+                  <action>tref.putAnnotation("javaname", javaname)</action>
+                  
                   <!-- remove the parameter and set the extent for the return type -->
                   <rule>indexed
                      <action>eref = tref.getImmediateChild(prog.lparens, null)</action>
@@ -284,6 +296,13 @@
                <rule>type == prog.kw_set
                   <!-- bulk setter -->
                   
+                  <!-- lookup and copy the bulk setter javaname (was deferred from naming.rules) -->
+                  <rule>copy.parent.isAnnotation("bulk-set-javaname")
+                     <action>javaname = copy.parent.getAnnotation("bulk-set-javaname")</action>
+                     <action on="false">javaname = "method_defs.rules_FIXME2"</action>
+                  </rule>
+                  <action>tref.putAnnotation("javaname", javaname)</action>
+                  
                   <!-- remove the index parameter and set the extent -->
                   <rule>indexed
                      <action>eref = tref.getImmediateChild(prog.lparens, null)</action>
@@ -328,9 +347,16 @@
                      <action>eref.putAnnotation("refid", vref.id)</action>
                   </rule>
 
-                  <!-- single-value setter -->
+                  <!-- "all" setter (single element parameter is assigned to all elements)  -->
                   <action>tref = mref.graftCopyTo(mref.parent, null)</action>
 
+                  <!-- lookup and copy the bulk getter javaname (was deferred from naming.rules) -->
+                  <rule>copy.parent.isAnnotation("set-all-javaname")
+                     <action>javaname = copy.parent.getAnnotation("set-all-javaname")</action>
+                     <action on="false">javaname = "method_defs.rules_FIXME3"</action>
+                  </rule>
+                  <action>tref.putAnnotation("javaname", javaname)</action>
+                  
                   <!-- remove the index parameter and don't set the extent -->
                   <rule>indexed
                      <action>eref = tref.getImmediateChild(prog.lparens, null)</action>
@@ -572,7 +598,7 @@
             <action on="false">putNote("classname", "void")</action>
          </rule>
          
-         <!-- conversion of javaname was already done during annotations_prep -->
+         <!-- conversion of javaname was already done during parsing -->
          <action>pname = getNoteString("name")</action>
          <action>javaname = getNoteString("javaname")</action>
          

=== modified file 'rules/annotations/naming.rules'
--- old/rules/annotations/naming.rules	2022-05-16 16:24:45 +0000
+++ new/rules/annotations/naming.rules	2022-05-22 12:23:43 +0000
@@ -7,7 +7,7 @@
 **
 ** Copyright (c) 2005-2022, Golden Code Development Corporation.
 **
-** _#_ _I_ __Date__ __JPRM__ ___________________________________Description___________________________________
+** _#_ _I_ __Date__ __JPRM__ __________________________________Description__________________________________
 ** 001 SIY 20051103   @23186 Initial implementation.
 ** 002 GES 20060124   @24051 Rewrote to enhance the annotations to provide
 **                           a more correct name mapping calculation.
@@ -47,7 +47,7 @@
 **     CA  20200508          Track the USING specs for each program - needed to solve cases when 
 **                           the imported class name is the same name as the program with the 
 **                           import statement.
-**     CA  20210609          Fixed extent property used as output/input-output argument.
+** 021 CA  20210609          Fixed extent property used as output/input-output argument.
 **     ME  20211022          Send the AST node as input to loadConvertedClass call.
 **     OM  20211111          Added transaction support for finally blocks.
 **     CA  20220427          Constructors names must be aware of overload suffixes (as their Java signature
@@ -55,6 +55,9 @@
 **     CA  20220428          Non-persistent programs are emitted only at the (Sub)AppObject service.
 **     CA  20220516          For explicit setter or getter for OO properties, force the index to be int64.
 **                           Fixed 'override' for OO properties.
+**     GES 20220501          Reworked convert_member_name to be convert_method_name. Rewrote usage of
+**                           ConvertedClassName to use ClassDefinition instead. Reworked method naming for
+**                           properties with extents.
 */
  -->
  
@@ -144,10 +147,11 @@
    <variable name="mname"       type="java.lang.String" />
    <variable name="pname"       type="java.lang.String" />
    <variable name="ename"       type="java.lang.String" />
+   <variable name="propkey"     type="java.lang.String" />
    <variable name="pkgbase"     type="java.lang.String" />
    <variable name="conflicts"   type="java.util.Set" />
    <variable name="iter"        type="java.util.Iterator" />
-   <variable name="cclass"      type="com.goldencode.p2j.uast.ConvertedClassName" />
+   <variable name="clsdef"      type="com.goldencode.p2j.uast.ClassDefinition" />
    <variable name="mAst"        type="com.goldencode.ast.Aast" />
    <variable name="ref"         type="com.goldencode.ast.Aast" />
    <variable name="ref2"        type="com.goldencode.ast.Aast" />
@@ -321,13 +325,12 @@
          <!-- this needs to be done first -->
          <action>setConvertedClassName(file, ooname, fullpkg, classname)</action>
          <!-- map the source file name to the converted class naming info -->
-         <action>cclass = loadConvertedClass(file, true, this)</action>
+         <action>clsdef = loadConvertedClass(file, true, this)</action>
 
          <!-- save the converted default constructor name at the root node -->
-         <action>mname = cclass.getLegacySimpleName()</action>
-         <action>
-            javaname = execLib("convert_member_name", mname, cclass, names.method, null)
-         </action>
+         <action>javaname = clsdef.getSimpleJavaName()</action>
+         <!-- TODO: do we need to register a method for this?  A better approach would be to calculate
+                    this at parse time -->
          <rule>pkgbase.isEmpty()
             <action>javaname = sprintf("__%s_constructor__", javaname)</action>
             <action on="false">javaname = sprintf("__%s_%s_constructor__", pkgbase, javaname)</action>
@@ -339,7 +342,7 @@
       <rule>relativePath("METHOD_DEF/KW_METHOD/SYMBOL")
          <action>mname = text</action>
          <action>
-            javaname = execLib("convert_member_name", mname, cclass, names.method, copy.parent.parent)
+            javaname = execLib("convert_method_name", mname, clsdef, copy.parent.parent)
          </action>
          <action>copy.parent.putAnnotation("javaname", javaname)</action>
       </rule>
@@ -347,8 +350,10 @@
       <rule>relativePath("CONSTRUCTOR/KW_CONSTRUC")
          <!-- to resolve constructor overload clash on object parameters, disambiguate here -->
          <action>mname = getNoteString("name")</action>
+         <!-- TODO: do we need to register a method for this?  A better approach would be to calculate
+                    this at parse time -->
          <action>
-            javaname = execLib("convert_member_name", mname, cclass, names.method, copy.parent)
+            javaname = execLib("convert_method_name", mname, clsdef, copy.parent)
          </action>
          <rule>pkgbase.isEmpty()
             <action>javaname = sprintf("__%s_constructor__", javaname)</action>
@@ -364,7 +369,10 @@
          relativePath("DEFINE_PROPERTY/KW_GET")    or
          relativePath("DEFINE_PROPERTY/KW_SET")
          
-         <!-- getter and setter method names are converted here -->
+         <!-- simple getter and setter method names already exist and are copied here; bulk getter and
+              bulk/all setters don't yet exist but their names are already converted; since there is no
+              method def yet for those we will defer lookup/copy of those until they exist (see the
+              process_getter_setter function in method_defs.rules) -->
          <action>pname = copy.parent.getAnnotation("name")</action>
          <action>putNote("name", pname)</action>
 
@@ -377,14 +385,17 @@
          </rule>
             
          <rule>type == prog.kw_get
+         
+            <!-- only the simple scalar/single element getter can be handled here -->
+            <action>pname = sprintf("get-%s", pname)</action>
+            <action>propkey = "get-javaname"</action>
+            
             <rule>downPath("LPARENS/PARAMETER") and parent.downPath("KW_EXTENT")  
                <!-- force the index parameter's data type to be int64 -->
                <action>ref2 = copy.getImmediateChild(prog.lparens, null)</action>
                <action>ref2 = ref2.getImmediateChild(prog.parameter, null)</action>
                <action>ref2.putAnnotation("classname", "int64")</action>
             </rule>
-         
-            <action>pname = cclass.disambiguateLegacyPropertyName("get", pname)</action>
             <action>
                mAst.putAnnotation("return_type", #(long) parent.getAnnotation("type"))
             </action>
@@ -401,7 +412,10 @@
                </rule>
 
                <action>mAst.putAnnotation("return_type", #(long) prog.kw_void)</action>
-               <action>pname = cclass.disambiguateLegacyPropertyName("set", pname)</action>
+               
+               <!-- only the simple scalar/single element setter can be handled here -->
+               <action>pname = sprintf("set-%s", pname)</action>
+               <action>propkey = "set-javaname"</action>
 
                <action>ref = createProgressAst(prog.parameter, ref)</action>
                <action>ref.putAnnotation("type", #(long) parent.getAnnotation("type"))</action>
@@ -425,9 +439,10 @@
                <action>mAst.setHidden(true)</action>
             </rule>
          </rule>
-         <action>
-            javaname = execLib("convert_member_name", pname, cclass, names.method, mAst)
-         </action>
+         <rule>copy.parent.isAnnotation(propkey)
+            <action>javaname = copy.parent.getAnnotation(propkey)</action>
+            <action on="false">javaname = "naming.rules_FIXME1"</action>
+         </rule>
          <action>
             mAst.putAnnotation("access-mode", #(long) parent.getAnnotation("access-mode"))
          </action>
@@ -448,7 +463,8 @@
             <action>pname = getNoteString("name")</action>
             
             <!-- - extent(property) will be like a function named length-of-property() -->
-            <action>ename = cclass.disambiguateLegacyPropertyName("length-of", pname)</action>
+            <action>ename = sprintf("length-of-%s", pname)</action>
+            <action>propkey = "length-of-javaname"</action>
             <!-- we temporary attach, to build the AST - will delete once done -->
             <action>mAst = createProgressAst(prog.kw_method, copy)</action>
             <action>ref = createProgressAst(prog.lparens, mAst)</action>
@@ -458,9 +474,10 @@
             <action>ref = createProgressAst(prog.kw_as, ref)</action>
             <action>ref = createProgressAst(prog.kw_int64, ref)</action>
             <action>mAst.setHidden(true)</action>
-            <action>
-               javaname = execLib("convert_member_name", ename, cclass, names.method, mAst)
-            </action>
+            <rule>copy.isAnnotation(propkey)
+               <action>javaname = copy.getAnnotation(propkey)</action>
+               <action on="false">javaname = "naming.rules_FIXME2"</action>
+            </rule>
             <action>mAst.putAnnotation("name", ename)</action>
             <action>mAst.putAnnotation("javaname", javaname)</action>
             <action>mAst.putAnnotation("oo-data-store", "METHOD")</action>
@@ -469,13 +486,15 @@
             <action>putNote("extent-length-javaname", javaname)</action>
             
             <!-- extent(property) = size will be like a function named resize-property() -->
-            <action>ename = cclass.disambiguateLegacyPropertyName("resize", pname)</action>
+            <action>ename = sprintf("resize-%s", pname)</action>
+            <action>propkey = "resize-javaname"</action>
             <action>mAst = createProgressAst(prog.kw_method, copy)</action>
             <action>ref = createProgressAst(prog.lparens, mAst)</action>
             <action>mAst.setHidden(true)</action>
-            <action>
-               javaname = execLib("convert_member_name", ename, cclass, names.method, mAst)
-            </action>
+            <rule>copy.isAnnotation(propkey)
+               <action>javaname = copy.getAnnotation(propkey)</action>
+               <action on="false">javaname = "naming.rules_FIXME3"</action>
+            </rule>
             <action>mAst.putAnnotation("name", ename)</action>
             <action>mAst.putAnnotation("javaname", javaname)</action>
             <action>mAst.putAnnotation("oo-data-store", "METHOD")</action>
@@ -484,14 +503,6 @@
             <action>putNote("extent-resize-javaname", javaname)</action>
          </rule>
       </rule>
-      
-      <rule>this.type == prog.define_variable and upPath("CLASS_DEF/BLOCK/STATEMENT")
-         <action>
-            cclass.addVariable(getNoteString("name"), 
-                               getNoteString("javaname"), 
-                               getNoteLong("extent"))
-         </action>
-      </rule>
    </walk-rules>
 
    <post-rules>

